#!/usr/bin/env python

import hadoopy

vector_path="hdfs://localhost:9000/vector"

vector=dict()

if hadoopy.exists(vector_path):
    kvs=hadoopy.readtb(vector_path)
    for k,v in kvs:
        vector[k]=v

def mapper(key, value):
    for v in value:
        yield  int(v.split(",")[0]), vector[int(key)]/len(value)
        
def reducer(key, values):
    yield key,sum(values)

if __name__ == "__main__":
    hadoopy.run(mapper, reducer, reducer, doc=__doc__)