#!/usr/bin/env python

import hadoopy
from operator import itemgetter

input_path = "hdfs://localhost:9000/edge_list.tb"
output_path = "hdfs://localhost:9000/vector"
temp_path = "hdfs://localhost:9000/temp"

labels_path="labels"
labels=map(lambda l:l.rstrip('\r\n'),list(open(labels_path)))
count=len(labels)

d=0.25

vector=[1./count]*count

if hadoopy.exists(output_path):
    hadoopy.rmr("-skipTrash %s"%output_path)
hadoopy.writetb(output_path,enumerate(vector))

diff=1.

while diff>0.01:
    if hadoopy.exists(temp_path):
        hadoopy.rmr("-skipTrash %s"%temp_path)
    
    hadoopy.launch(input_path, temp_path, 'PageRank.py')    

    result=hadoopy.readtb(temp_path)    
    
    new_v=[d*1./count]*count
    diff=0
    
    for (k,v) in result:
        new_v[k]+=(1-d)*v
        diff+=abs(new_v[k]-vector[k])
    
    vector=new_v
    
    hadoopy.rmr("-skipTrash %s"%output_path)
    hadoopy.writetb(output_path,enumerate(new_v))
    
    print diff
    
max_id, pagerank=max(enumerate(vector), key=itemgetter(1))

print "%s: %f" % (labels[max_id],pagerank)